<?php

namespace Drupal\Tests\acquia_dam\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * Test Acquia Dam and Media Acquia Dam form alter.
 *
 * @group acquia_dam
 * @requires module media_acquiadam
 */
final class MediaAcquiaDamFormAlterTest extends BrowserTestBase {

  /**
   * User that has admin permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stable';

  /**
   * Modules to enable.
   *
   * @var array
   */
  protected static $modules = [
    'acquia_dam',
    'media_acquiadam',
  ];

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    // PHPUnit has `checkRequirements` as a private method since 9.x.
    // We run Drupal's `checkRequirements` again, here, to verify our module
    // requirement.
    // @todo remove after https://www.drupal.org/i/3261817
    $this->checkRequirements();

    parent::setUp();
    $this->adminUser = $this->drupalCreateUser([], 'TestAdmin', TRUE);
  }

  /**
   * Test media Acquia DAM form alter.
   *
   * @throws \Behat\Mink\Exception\ExpectationException
   * @throws \Behat\Mink\Exception\ResponseTextException
   */
  public function testFormAlter():void {
    $this->drupalLogin($this->adminUser);
    $session = $this->assertSession();

    $this->drupalGet('/admin/config/media/acquiadam');

    $session->statusCodeEquals(200);
    $session->pageTextContains('The site credentials to your Acquia DAM account are now under Acquia DAM');
    $session->linkByHrefExists('/admin/config/acquia-dam');
  }

}
