<?php

namespace Drupal\Tests\acquia_dam\FunctionalJavascript;

use Drupal\Tests\media\Traits\MediaTypeCreationTrait;

/**
 * Test save button is disabled for acquia dam add media form.
 *
 * @group acquia_dam
 */
class MediaAddFormTest extends AcquiaDamWebDriverTestBase {
  use MediaTypeCreationTrait;


  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stable';

  /**
   * User that has admin permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  protected function setUp():void {
    parent::setUp();
    $this->adminUser = $this->drupalCreateUser([
      'administer site configuration',
      'access media overview',
      'create media',
    ]);
  }

  /**
   * Test is to check if the save button is disabled for dam assets.
   */
  public function testAddMediaForm() {
    $this->drupalLogin($this->adminUser);
    $image = $this->createMediaType('image');
    $this->drupalGet('/media/add/acquia_dam_documents_asset');
    $save_button = $this->assertSession()->waitForElement('css', '#edit-submit');
    self::assertTrue($save_button->hasAttribute('disabled'));
    $this->drupalGet('/media/add/' . $image->id());
    $save_button = $this->assertSession()->waitForElement('css', '#edit-submit');
    self::assertFalse($save_button->hasAttribute('disabled'));
  }

}
