<?php

namespace Drupal\Tests\acquia_dam\FunctionalJavascript;

/**
 * Test Acquia Dam site registration.
 *
 * @group acquia_dam
 */
class UserAuthPageTest extends AcquiaDamWebDriverTestBase {

  /**
   * User that has admin permissions.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $adminUser;

  /**
   * {@inheritdoc}
   */
  public function setUp(): void {
    parent::setUp();
    $this->adminUser = $this->drupalCreateUser([
      'administer site configuration',
    ]);

  }

  /**
   * Test the auth page content.
   */
  public function testAuthPageContent() {
    $this->drupalLogin($this->adminUser);
    $session = $this->assertSession();
    $this->grantDamDomain();
    $uid = $this->adminUser->id();
    $this->drupalGet("/user/{$uid}/acquia-dam");
    $session->pageTextContains('Connect to Acquia Dam');
    $this->grantCurrentUserDamToken();
    $this->drupalGet("/user/{$uid}/acquia-dam");
    $session->pageTextContains('Disconnect from Acquia DAM');

  }

}
