<?php

namespace Drupal\Tests\acquia_dam\Kernel;

/**
 * Tests DAM authentication service disconnectSiteAndUsers method.
 *
 * @group acquia_dam
 */
class DamDomainChangeTest extends AcquiaDamKernelTestBase {

  /**
   * Tests that handleDomainChange deletes user and site tokens.
   *
   * @throws \Drupal\Core\Entity\EntityStorageException
   */
  public function testSiteAndUsersDisconnect(): void {
    $this->grantDamDomain('test.widencollective.disconnect');
    $this->setDamSiteToken();
    $this->drupalSetUpCurrentUser();

    /** @var \Drupal\acquia_dam\AcquiadamAuthService $auth_service */
    $auth_service = \Drupal::service('acquia_dam.authentication_service');

    $user_data = \Drupal::service('user.data');
    $this->assertNotEmpty($user_data->get('acquia_dam'));
    $auth_service->disconnectSiteAndUsers();
    $this->assertEmpty($auth_service->getSiteToken());
    $this->assertEmpty($user_data->get('acquia_dam'));
  }

}
